package com.persagy.apm.energy.report.common.utils;

import org.nfunk.jep.JEP;

import java.math.BigDecimal;

public class DataUtils {
    /**
     * 对象转Double类型
     *
     * @param object
     * @return
     */
    public static Double parseDouble(Object object) {
        if (object == null) {
            return null;
        }
        if (object instanceof String) {
            return Double.valueOf(object.toString());
        }
        if (object instanceof Integer) {
            return ((Integer) object).doubleValue();
        }
        if (object instanceof Long) {
            return ((Long) object).doubleValue();
        }
        if (object instanceof Double) {
            return (Double) object;
        }
        if (object instanceof BigDecimal) {
            return ((BigDecimal) object).doubleValue();
        }
        return (Double) object;
    }

    /**
     * 按规则进行计算
     *
     * @param standardValue 规则值
     * @param qualifyFormula 规则
     * @param data 要进行规则校验的数据
     * @return
     */
    public static Double getQualifyResult(Double standardValue, String qualifyFormula, Double data) {
        JEP jep = new JEP();
        String formula = "param1" + qualifyFormula + "param2";
        jep.addVariable("param1", standardValue);
        jep.addVariable("param2", data);
        jep.parseExpression(formula);
        return jep.getValue();
    }

}
